# Get environment config modifiers

`GET /v1/environments/{environmentId}/operations/configmodifiers`

Available as MCP tool `get-config-modifiers-by-environment` (Read).

Config modifier endpoints allow you to review and manage config modifiers and their related links. [Learn about config modifiers](https://docs.redoxengine.com/permalink/1wyRkO4LmBwAMmsKArQoIr). 

Anyone in a Redox organization can view config modifiers and related links, but you must be assigned to an engineer or support role to update them.

You can:

- retrieve a list of config modifiers by environment or organization;
- create config modifiers or links;
- update config modifiers or links; or
- delete config modifiers or link.

### Get environment config modifiers

Retrieve a list of existing config modifiers for a specific environment within a Redox organization. You can only retrieve a list of config modifiers for one environment per query.

The response contains a list of config modifiers with matching links based on the defined query parameters. However, if a config modifier is returned, the object contains all its associated links, not just the links that match the query parameters. If no links match the query parameters, the config modifier list is empty. 

## Request parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `environmentId` | path | string | Yes | Identifies the specific environment that you're operating in or on behalf of. |
| `_page` | query | number | No | Indicates a specific page of results to return. This value typically comes from a previous response's `page` object. |
| `_count` | query | number | No | Defines the number of results to return per page. The maximum value per page is 50. |
| `name` | query | string | No | Specifies the name of the config modifier. |
| `connectionId` | query | string | No | Specifies the unique identifier of the connection where the config modifier is linked. |
| `dataModel` | query | string | No | Identifies the Redox data model or FHIR resource that the config modifier is linked to. |
| `sourceId` | query | string | No | Specifies the unique identifier of the source that the config modifier is linked to. |
| `destinationId` | query | string | No | Specifies the unique identifier of the destination that the config modifier is linked to. |

## Request example

```bash
curl 'https://api.redoxengine.com/platform/v1/environments/{environmentId}/operations/configmodifiers' \
--request GET \
--header 'Authorization: Bearer $API_TOKEN' \
--header 'accept: application/json'
```

## Responses

### 200

Contains a payload object with a list of config modifiers.

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `meta` | object | No | Contains metadata about paginated results of returned data. |
| `meta.version` | string | No | Lists the major and minor version number for the format of the returned payload. The payload format or shape may change between minor versions, like including additional or extended fields in later versions. We include the version data in each response so that you have the option to handle the signaled differences. |
| `meta.totalRecords` | number | No | Specifies the total number of records across all pages for the result set. |
| `meta.links` | object | No |  |
| `meta.links.self` | string | No | Links to the current page of results. |
| `meta.links.next` | string | No | Links to the next page of results. |
| `meta.links.prev` | string | No | Links to the previous page of results, which returns the page based on the current page you're on. |
| `meta.links.first` | string | No | Links to the first page of results. |
| `meta.links.last` | string | No | Links to the last page of results. |
| `meta.currentPage` | number | No | Specifies the current page number. |
| `meta.pageType` | string | No | Describes the pagination algorithm. Value: offest |
| `meta.pageSize` | number | No | Describes the number of records included in each page of the current result set. |
| `payload` | object | No | Contains the payload with details about the requested config modifier(s). |
| `payload.configModifiers` | Array of object | No | Contains an array of config modifiers. |
| `payload.configModifiers[].id` | string (uuid) | No | Contains the unique identifier of the config modifier. |
| `payload.configModifiers[].version` | number | No | Indicates the iteration, or version number, of the config modifier. Version numbers start at 1 and increment every time a config modifier is updated. |
| `payload.configModifiers[].name` | string | No | Displays the human-readable name of the config modifier. |
| `payload.configModifiers[].flavor` | string | No | Indicates the type, or flavor, of config modifier. A `put` flavor alters data (creates or replaces) in a payload, while a `delete` flavor removes data from a payload. Possible values: put, delete |
| `payload.configModifiers[].selector` | string | No | Indicates the location(s) within the payload that this config modifier will operate on. |
| `payload.configModifiers[].schema` | object, nullable | No | Required for a `put` flavor config modifier. Indicates how to build the value at the location the selector specifies. |
| `payload.configModifiers[].createdAt` | string | No | Displays the date and time that the asset was originally created in ISO 8601 format. |
| `payload.configModifiers[].createdBy` | object | No | Contains the metadata about the user who created the asset. |
| `payload.configModifiers[].createdBy.id` | number | No | Contains the unique identifier of the user. |
| `payload.configModifiers[].createdBy.name` | string, nullable | No | Displays the user's full name. |
| `payload.configModifiers[].updatedAt` | string | No | Displays the date and time that the asset was last updated in ISO 8601 format. |
| `payload.configModifiers[].updatedBy` | object | No | Contains the metadata about the user who last updated the asset. |
| `payload.configModifiers[].updatedBy.id` | number | No | Contains the unique identifier of the user. |
| `payload.configModifiers[].updatedBy.name` | string, nullable | No | Displays the user's full name. |
| `payload.configModifiers[].deletedAt` | string, nullable | No | Displays the date and time that the asset was deleted. Returns a `null` value if the asset hasn't been deleted. |
| `payload.configModifiers[].deletedBy` | object, nullable | No | Contains the metadata about the user who deleted the asset. |
| `payload.configModifiers[].deletedBy.id` | number | No | Contains the unique identifier of the user. |
| `payload.configModifiers[].deletedBy.name` | string, nullable | No | Displays the user's full name. |
| `payload.configModifiers[].environment` | object | No | Describes the Redox environment that the asset belongs to. |
| `payload.configModifiers[].environment.id` | string (uuid) | No | Contains the unique identifier of the Redox environment. |
| `payload.configModifiers[].organization` | object | No | Describes the Redox organization that the asset belongs to. |
| `payload.configModifiers[].organization.id` | number | No | Contains the unique identifier of the Redox organization. |
| `payload.configModifiers[].organization.name` | string, nullable | No | Contains the human-readable name of the Redox organization. |
| `payload.configModifiers[].usage` | Array of object | No |  |
| `payload.configModifiers[].usage[].ownedBy` | string | No | Indicates whether the source or destination system owns the link. Only the owner can view the specific details or update a link. Possible values: source, destination |
| `payload.configModifiers[].usage[].linkId` | string (uuid) | No | Contains the unique identifier of the link for a specified asset. |
| `payload.configModifiers[].usage[].organization` | object | No | Describes the Redox organization that the asset belongs to. |
| `payload.configModifiers[].usage[].organization.id` | number | No | Contains the unique identifier of the Redox organization. |
| `payload.configModifiers[].usage[].organization.name` | string, nullable | No | Contains the human-readable name of the Redox organization. |
| `payload.configModifiers[].usage[].connectingOrganization` | object | No | Specifies the organization the asset is connected to when the subscription relates to a partner organization. |
| `payload.configModifiers[].usage[].connectingOrganization.id` | number | No | Contains the unique identifier of the Redox organization. |
| `payload.configModifiers[].usage[].connectingOrganization.name` | string, nullable | No | Contains the human-readable name of the Redox organization. |
| `payload.configModifiers[].usage[].processingLocation` | string | No | Identifies where a link will be applied during log processing. There are up to four stages that an asset can be linked to, depending on whether you own either the source, the destination, or both. Possible values: source-request, destination-request, source-response, destination-response |
| `payload.configModifiers[].usage[].subscription` | object | No |  |
| `payload.configModifiers[].usage[].subscription.dataModel` | string | No | Specifies the Redox data model that the link applies to or should apply to. |
| `payload.configModifiers[].usage[].subscription.source` | object | No | Specifies the source of the subscription that an asset is or should be linked to. |
| `payload.configModifiers[].usage[].subscription.source.id` | string (uuid) | Yes | Contains the unique identifier of the source. |
| `payload.configModifiers[].usage[].subscription.source.name` | string, nullable | No | Specifies the name of the source. |
| `payload.configModifiers[].usage[].subscription.destination` | object | No | Specifies the destination of the subscription that an asset is or should be linked to. |
| `payload.configModifiers[].usage[].subscription.destination.id` | string (uuid) | Yes | Contains the unique identifier of the destination. |
| `payload.configModifiers[].usage[].subscription.destination.name` | string, nullable | No | Specifies the name of the destination. |
| `payload.configModifiers[].usage[].eventTypes` | Array of string, nullable | No | Specifies the event types of the given Redox data model that the link applies to. If `null`, the config modifier is linked to all event types of the data model. |
| `payload.configModifiers[].usage[].processingOrder` | object | No | Contains the details for the processing order of the config modifiers linked to a given subscription. |
| `payload.configModifiers[].usage[].processingOrder.order` | number, nullable | No | Specifies the order that the config modifiers should run at the given processing location. |
| `payload.configModifiers[].usage[].processingOrder.total` | number | No | Displays the total number of config modifier links for the given subscription and processing location. |
| `payload.configModifiers[].promotionAssociations` | Array of object | No | Contains a list of promotions associated with this asset. |
| `payload.configModifiers[].promotionAssociations[].organization` | object | No | Describes the Redox organization that the asset belongs to. |
| `payload.configModifiers[].promotionAssociations[].organization.id` | number | No | Contains the unique identifier of the Redox organization. |
| `payload.configModifiers[].promotionAssociations[].organization.name` | string, nullable | No | Contains the human-readable name of the Redox organization. |
| `payload.configModifiers[].promotionAssociations[].fromAsset` | object | No | Describes the original asset that was created in staging and promoted to production. |
| `payload.configModifiers[].promotionAssociations[].fromAsset.id` | string (uuid) | No | Contains the unique identifier of the asset. |
| `payload.configModifiers[].promotionAssociations[].fromAsset.environment` | object | No | Describes the Redox environment that the asset belongs to. |
| `payload.configModifiers[].promotionAssociations[].fromAsset.environment.id` | string (uuid) | No | Contains the unique identifier of the Redox environment. |
| `payload.configModifiers[].promotionAssociations[].fromAsset.type` | string | No | Possible values: configModifier, filter, translationSet |
| `payload.configModifiers[].promotionAssociations[].fromAsset.latestVersion` | number | No | Displays the most recent version of the original asset in staging. This may vary from the version number in production. A different version number may indicate you need to re-promote the asset to production. |
| `payload.configModifiers[].promotionAssociations[].toAsset` | object | No | Describes the promoted asset that can be used or linked to subscriptions in production. |
| `payload.configModifiers[].promotionAssociations[].toAsset.id` | string (uuid) | No | Contains the unique identifier of the asset. |
| `payload.configModifiers[].promotionAssociations[].toAsset.environment` | object | No | Describes the Redox environment that the asset belongs to. |
| `payload.configModifiers[].promotionAssociations[].toAsset.environment.id` | string (uuid) | No | Contains the unique identifier of the Redox environment. |
| `payload.configModifiers[].promotionAssociations[].toAsset.type` | string | No | Possible values: configModifier, filter, translationSet |
| `payload.configModifiers[].promotionAssociations[].toAsset.latestVersion` | number | No | Displays the most recent version of the promoted asset in production. This may vary from the version number in staging. A different version number may indicate you need to re-promote the staging asset to production. |
| `payload.configModifiers[].promotionAssociations[].toAsset.outOfDate` | boolean | No | Indicates whether the version of the promoted asset in production is different from the version of the original asset in staging. |
| `payload.configModifiers[].promotionAssociations[].createdAt` | string | No | Displays the date and time that the asset was originally created in ISO 8601 format. |
| `payload.configModifiers[].promotionAssociations[].createdBy` | object | No | Contains the metadata about the user who created the asset. |
| `payload.configModifiers[].promotionAssociations[].createdBy.id` | number | No | Contains the unique identifier of the user. |
| `payload.configModifiers[].promotionAssociations[].createdBy.name` | string, nullable | No | Displays the user's full name. |
| `payload.configModifiers[].promotionAssociations[].updatedAt` | string | No | Displays the date and time that the asset was last updated in ISO 8601 format. |
| `payload.configModifiers[].promotionAssociations[].updatedBy` | object | No | Contains the metadata about the user who last updated the asset. |
| `payload.configModifiers[].promotionAssociations[].updatedBy.id` | number | No | Contains the unique identifier of the user. |
| `payload.configModifiers[].promotionAssociations[].updatedBy.name` | string, nullable | No | Displays the user's full name. |
| `payload.configModifiers[].promotionAssociations[].deletedAt` | string, nullable | No | Displays the date and time that the asset was deleted. Returns a `null` value if the asset hasn't been deleted. |
| `payload.configModifiers[].promotionAssociations[].deletedBy` | object, nullable | No | Contains the metadata about the user who deleted the asset. |
| `payload.configModifiers[].promotionAssociations[].deletedBy.id` | number | No | Contains the unique identifier of the user. |
| `payload.configModifiers[].promotionAssociations[].deletedBy.name` | string, nullable | No | Displays the user's full name. |

_Generated from the schema: the values are placeholders, not a real payload._

```json
{
  "meta": {
    "version": "1.0.0",
    "totalRecords": 0,
    "links": {
      "self": "string",
      "next": "string",
      "prev": "string",
      "first": "string",
      "last": "string"
    },
    "currentPage": 1,
    "pageType": "offest",
    "pageSize": 0
  },
  "payload": {
    "configModifiers": [
      {
        "id": "3c45db50-6bb2-4cca-b1f9-76125ae9770f",
        "version": 0,
        "name": "string",
        "flavor": "put",
        "selector": "$.Patient.Identifiers[*].ID",
        "schema": {
          "plugin": {
            "name": "text",
            "action": "upper-case"
          }
        },
        "createdAt": "2024-04-25T18:17:16.719Z",
        "createdBy": {
          "id": 0,
          "name": "string"
        },
        "updatedAt": "2024-04-25T18:17:16.719Z",
        "updatedBy": {
          "id": 0,
          "name": "string"
        },
        "deletedAt": "2024-04-25T18:17:16.719Z",
        "deletedBy": {
          "id": 0,
          "name": "string"
        },
        "environment": {
          "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08"
        },
        "organization": {
          "id": 122,
          "name": "string"
        },
        "usage": [
          {
            "ownedBy": "source",
            "linkId": "009f739c-6620-43b0-978e-b245e723c57a",
            "organization": {
              "id": 122,
              "name": "string"
            },
            "connectingOrganization": {
              "id": 122,
              "name": "string"
            },
            "processingLocation": "source-request",
            "subscription": {
              "dataModel": "PatientAdmin",
              "source": {
                "name": "string",
                "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08"
              },
              "destination": {
                "name": "string",
                "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08"
              }
            },
            "eventTypes": [
              "string"
            ],
            "processingOrder": {
              "order": 0,
              "total": 0
            }
          }
        ],
        "promotionAssociations": [
          {
            "organization": {
              "id": 122,
              "name": "string"
            },
            "fromAsset": {
              "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
              "environment": {
                "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08"
              },
              "type": "configModifier",
              "latestVersion": 0
            },
            "toAsset": {
              "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
              "environment": {
                "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08"
              },
              "type": "configModifier",
              "latestVersion": 0,
              "outOfDate": true
            },
            "createdAt": "2024-04-25T18:17:16.719Z",
            "createdBy": {
              "id": 0,
              "name": "string"
            },
            "updatedAt": "2024-04-25T18:17:16.719Z",
            "updatedBy": {
              "id": 0,
              "name": "string"
            },
            "deletedAt": "2024-04-25T18:17:16.719Z",
            "deletedBy": {
              "id": 0,
              "name": "string"
            }
          }
        ]
      }
    ]
  }
}
```

### 400

Contains a payload of an error.

#### One of: Option 1

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `payload` | object | No | Contains the error message. |
| `payload.error` | object | No | Contains the error message details. |
| `payload.error.id` | string | No | Contains the ID for this specific error |
| `payload.error.title` | string | No | Displays the high-level error message, typically something succinct like `Bad Request`. |
| `payload.error.code` | string | No | Contains an alternative ID for the error type, which can be used to find relevant troubleshooting information. |
| `payload.error.detail` | string | No | Contains the specific error details for this message. |
| `payload.error.status` | number | No | Displays the corresponding HTTP status code for the error. |

#### One of: Option 2

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `payload` | object | No | Contains the error message. |
| `payload.error` | object | No | Contains the error message details. |
| `payload.error.id` | string | No | Contains a unique identifier for the given error instance. |
| `payload.error.title` | string | No | Displays the high-level error message, typically something succinct like `Bad Request`. |
| `payload.error.code` | string | No | Contains an alternative ID for the error type, which can be used to find relevant troubleshooting information. |
| `payload.error.detail` | string | No | Contains the specific error details for this message. |
| `payload.error.status` | number | No | Displays the corresponding HTTP status code for the error. |
| `payload.error.transient` | boolean | No | Describes whether the error will resolve itself. If `true`, no further action needs to be taken. If `false`, you may need to troubleshoot on your end to resolve the issue before the error can be processed. |

```json
{
  "payload": {
    "error": {
      "id": "query-e049f44d-99b2-4790-b4c6-19c0c21d1234",
      "title": "Request received but has an invalid parameter",
      "code": "request.invalid.param",
      "detail": "Provided query parameters are invalid",
      "status": 400
    }
  }
}
```

### 403

Forbidden

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `payload` | object | No | Contains the error message. |
| `payload.errors` | Array of object | No |  |
| `payload.errors[].title` | string | No | Displays the high-level error message, typically something succinct like `Forbidden`. |
| `payload.errors[].code` | string | No | Contains an alternative ID for the error type, which can be used to find relevant troubleshooting information. |

```json
{
  "payload": {
    "errors": [
      {
        "title": "Forbidden",
        "code": "authorization.forbidden"
      }
    ]
  }
}
```

### 500

Internal Server Error

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `payload` | object | No | Contains the error message. |
| `payload.error` | object | No | Contains the error message details. |
| `payload.error.title` | string | No | Displays the high-level error message, typically something succinct like `Failed in step X`. |
| `payload.error.code` | string | No | Contains an alternative ID for the error type, which can be used to find relevant troubleshooting information. |
| `payload.error.detail` | string | No | Contains the specific error details for this message. |
| `payload.error.status` | number | No | Displays the corresponding HTTP status code for the error. |
| `payload.error.transient` | boolean | No | Describes whether the error will resolve itself. If `true`, no further action needs to be taken. If `false`, you may need to troubleshoot on your end to resolve the issue before the error can be processed. |

```json
{
  "payload": {
    "error": {
      "title": "Internal Server Error",
      "code": "failed.db.lookup",
      "detail": "Error details",
      "status": 500,
      "transient": true
    }
  }
}
```
